//+------------------------------------------------------------------+
//|                                                             .mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                            "http://www.mql4.com/ru/users/costy_" |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.mql4.com/ru/users/costy_"

#property indicator_chart_window
extern int    Method             = 0;
extern int    PipRangeForMethod0 =  100;
extern int    WeeksToDraw        = 5;
extern string description        = "level";
extern color  color_Fibo         = Gold;


//     
datetime SaveBeginTimeDay;
string Str_fibo_yrovni[21]={"0","0.236","0.382","0.5","0.618","1","1.61","2.61","3.61","4.23","4.61","-0.236","-0.382","-0.5","-0.618","-1","-1.61","-2.61","-3.61","-4.23","-4.61"};
double fibo_yrovni[21]={0,0.236,0.382,0.5,0.618,1,1.61,2.61,3.61,4.23,4.61,-0.236,-0.382,-0.5,-0.618,-1,-1.61,-2.61,-3.61,-4.23,-4.61};
// init  
int init(){ return(0);}
// deinit 

//
//
//
//
//

#define __theName "iFiboLevels"
void deleteFibos()
{
   string seekFor    = __theName;
   int    seekLength = StringLen(seekFor);
   
      //
      //
      //
      //
      //
      
      for (int i=ObjectsTotal(); i>=0; i--)
      {
         string name = ObjectName(i);
            if (StringSubstr(name,0,seekLength) == seekFor)
                ObjectDelete(name);
      }
}
int deinit() { deleteFibos(); return(0);}

//
//
//
//
//

int start()
{
   datetime startTime   = Time[0];
   int      totalWeeks  = 0;
   int      pipModifier = 1;
            if (Digits==3 || Digits==5) pipModifier = 10;
            if (Period()>PERIOD_D1) return(0);
   //
   //
   //
   //
   //

   deleteFibos();
   for (int i=0; i<Bars && totalWeeks<WeeksToDraw ; i++)
   {
      int shift1 = iBarShift(NULL,PERIOD_W1,Time[i]);
      int shift2 = iBarShift(NULL,PERIOD_W1,Time[i+1]);
      if (shift1 != shift2)
      {
        string name = __theName+totalWeeks;
        
        if(Method==0)
               ObjectCreate(name,OBJ_FIBO,0,Time[i],Open[i]+PipRangeForMethod0*Point*pipModifier,Time[i]+Barof(),Open[i]);
        else   ObjectCreate(name,OBJ_FIBO,0,Time[i],iOpen(NULL,PERIOD_W1,shift2)                ,Time[i]+Barof(),Open[i]);
                  ObjectSet(name,OBJPROP_RAY,false);
                  ObjectSet(name,OBJPROP_FIBOLEVELS,21);
                  ObjectSet(name,OBJPROP_COLOR,EMPTY);
                  ObjectSet(name,OBJPROP_LEVELCOLOR,color_Fibo);
        
                  for (int k=0; k<=21; k++)
                  {
                     ObjectSet(name,OBJPROP_FIRSTLEVEL+k,fibo_yrovni[k]);
                     ObjectSetFiboDescription(name,k,description+" "+Str_fibo_yrovni[k]+"  ");
                  }
                  totalWeeks++;
                  startTime = Time[i+1];
       }
   }
   return(0);
}

int Barof(){
   switch(Period())
   {
      case PERIOD_M1:  return(720*Period()*60);
      case PERIOD_M5:  return(143*Period()*60);
      case PERIOD_M15: return( 47*Period()*60);
      case PERIOD_M30: return( 23*Period()*60);
      case PERIOD_H1:  return( 11*Period()*60);
      case PERIOD_H4:  return(  3*Period()*60);
      case PERIOD_D1:  return(  1*Period()*60);
   }
}